/*
 * RRGAlgebraic.h
 *
 *  Created on: 4. 3. 2014
 *      Author: tomas
 */

#ifndef RRGALGEBRAIC_H_
#define RRGALGEBRAIC_H_

#include <grammar/Regular/RightRegularGrammar.h>
#include <regexp/RegExp.h>

#include "../../shared/equations/RightRegularEquationSolver.h"
#include "../../interface/IConversionRE.h"

namespace conversions
{

class RRGAlgebraic: public IConversionRE
{
public:
    /**
     * @param rg Source right regular grammar.
     */
    RRGAlgebraic( const grammar::RightRegularGrammar & rg );

    ~RRGAlgebraic( void );

    /**
     * @return regexp equivalent to source right regular grammar.
     */
    regexp::RegExp convert( void );

protected:
    /**
     * input grammar
     */
    const grammar::RightRegularGrammar & m_grammar;
};

} /* namespace conversions */

#endif /* RRGALGEBRAIC_H_ */
