/*
 * aintegral.cpp
 *
 *  Created on: 24. 2. 2014
 *      Author: Tomas Pecka
 */

#include <iostream>

#include <factory/DataFactory.hpp>
#include <exception/AlibException.h>

#include "regexp/RegExpIntegral.h"

int main(int argc, char** argv)
{
    try
    {
        if(argc == 2 && std::string("-h").compare(argv[1]) == 0)
        {
            std::cout << "aintegral. Integrates regular expression by given string." << std::endl;
            std::cout << "Usage: aintegral regexp.xml string.xml" << std::endl;
            return -1;
        }

        if(argc == 3)
        {
            regexp::RegExp regexp = alib::DataFactory::fromFile<regexp::RegExp>(argv[1]);
            string::LinearString* string = static_cast<string::LinearString*>(std::move(alib::DataFactory::fromFile<string::LinearString>(argv[2])).plunder());

            regexp::RegExpIntegral i;
            alib::DataFactory::toStdout(i.integral(regexp, *string));

            return 0;
        }
    }
    catch(const exception::AlibException& exception)
    {
        alib::DataFactory::toStdout(exception);
        return 1;
    }
    catch(...)
    {
        return 127;
    }
}
