/*
 * AutomatonPropertiesFSM.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef AUTOMATON_PROPERTIED_FSM_H_
#define AUTOMATON_PROPERTIED_FSM_H_

#include <algorithm>
#include <deque>
#include <set>

#include <automaton/common/State.h>

namespace automaton {

class AutomatonPropertiesFSM {
public:
	/**
	 * Removes dead states from FSM. Melichar 2.32
	 */
	template<class T>
	static std::set<automaton::State> getUsefullStates( const T & fsm );

	/**
	 * Removes dead states from FSM. Melichar 2.29
	 */
	template<class T>
	static std::set<automaton::State> getUnreachableStates( const T & fsm );
};

}

#endif /* AUTOMATON_PROPERTIED_FSM_H_ */
