/*
 * Brzozowski.h
 *
 *  Created on: 11. 1. 2014
 *      Author: tomas
 */

#ifndef BRZOZOWSKI_H_
#define BRZOZOWSKI_H_

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>
#include <automaton/FSM/DFA.h>

namespace re2fa
{

/**
 * Converts regular expression to finite automaton using Brzozowski algorithm (derivations of regular expressions).
 * Source: Melichar 2.110
 */
class Brzozowski : public regexp::VisitableRegExpBase::visitor_type
{
public:
    Brzozowski(void);
    ~Brzozowski(void);

    /**
     * Performs conversion.
     * @return FSM equivalent to original regular expression.
     */
    automaton::DFA convert(const regexp::RegExp& regexp);

private:
    void Visit(void* , const regexp::FormalRegExp& regexp);
    void Visit(void* , const regexp::UnboundedRegExp& regexp);
};

} /* namespace re2fa */

#endif /* BRZOZOWSKI_H_ */
