/*
 * BrzozowskiDerivationRRG.h
 *
 *  Created on: 6. 3. 2014
 *      Author: tomas
 */

#ifndef BRZOZOWSKIDERIVATIONRRG_H_
#define BRZOZOWSKIDERIVATIONRRG_H_

#include <grammar/Regular/RightRG.h>
#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

namespace re2rg
{

/**
 * Converts reg. expression to right regular grammar using brzozowski derivation algorithm.
 * Source: Melichar 2.137
 */
class BrzozowskiDerivationRRG : public regexp::VisitableRegExpBase::visitor_type
{
public:
    BrzozowskiDerivationRRG(void);
    ~BrzozowskiDerivationRRG(void);

    /**
     * Performs conversion.
     * @return right regular grammar equivalent to source regexp.
     */
    grammar::RightRG convert(const regexp::RegExp& regexp);

private:
    void Visit(void*, const regexp::FormalRegExp& regexp);
    void Visit(void*, const regexp::UnboundedRegExp& regexp);
};

} /* namespace re2rg */

#endif /* BRZOZOWSKIDERIVATIONRRG_H_ */
