#ifndef __LRGTOFACONVERTER_H__
#define __LRGTOFACONVERTER_H__

#include <grammar/Regular/LeftRG.h>
#include <automaton/FSM/NFA.h>

namespace rg2fa
{

/**
 * Converts left regular grammar to finite automaton.
 * Source: Melichar 2.102.
 */
class LRGtoFAConverter
{
public:
    /**
     * Performs conversion.
     * @return FSM equivalent to source grammar.
     */
    automaton::NFA convert(const grammar::LeftRG& grammar);
};

} /* namespace rg2fa */

#endif /* __LRGTOFACONVERTER_H__ */
