/*
 * RightToLeftRegularGrammar.h
 *
 *  Created on: 8. 3. 2014
 *      Author: Tomas Pecka
 */

#ifndef RIGHT_TO_LEFT_REGULAR_GRAMMAR_H_
#define RIGHT_TO_LEFT_REGULAR_GRAMMAR_H_

#include <grammar/Regular/LeftRG.h>
#include <grammar/Regular/RightRG.h>

namespace rg2rg
{

/**
 * Converts right regular grammar to left regular grammar.
 */
class RightToLeftRegularGrammar
{
public:
    /**
     * Performs conversion.
     * @return left regular grammar which is equivalent to source right regular grammar.
     */
    grammar::LeftRG convert(const grammar::RightRG& rrg);
};

} /* namespace rg2rg */

#endif /* RIGHT_TO_LEFT_REGULAR_GRAMMAR_H_ */
