/*
 * RandomAutomatonFactory.h
 *
 *  Created on: 27. 3. 2014
 *      Author: Tomas Pecka
 */

#ifndef RANDOM_AUTOMATON_FACTORY_H_
#define RANDOM_AUTOMATON_FACTORY_H_

#include <deque>
#include <set>

#include <exception/AlibException.h>
#include <automaton/FSM/NFA.h>

namespace generator {

class RandomAutomatonFactory {
public:
    static automaton::NFA generateNFA( size_t statesCount, std::set<alphabet::Symbol> alphabet, double density );
    static automaton::NFA generateNFA( size_t statesCount, size_t alphabetSize, double density );

private:
    static automaton::NFA LeslieConnectedNFA( size_t n, const std::deque<alphabet::Symbol> & alphabet, double density );
};

}

#endif /* RANDOM_AUTOMATON_FACTORY_H_ */
