/*
 * RegExpEpsilon.cpp
 *
 *  Created on: 19. 1. 2014
 *      Author: Tomas Pecka
 */

#include "RegExpEpsilon.h"

namespace regexp
{

bool RegExpEpsilon::languageContainsEpsilon(const regexp::RegExp& regexp)
{
    bool out;
    regexp.getData().Accept((void*) &out, RegExpEpsilon::REG_EXP_EPSILON);
    return out;
}

bool RegExpEpsilon::languageContainsEpsilon(const regexp::FormalRegExp& regexp)
{
	return regexp.containsEmptyString();
}

bool RegExpEpsilon::languageContainsEpsilon(const regexp::UnboundedRegExp& regexp)
{
	return regexp.containsEmptyString();
}

void RegExpEpsilon::Visit(void* userData, const regexp::FormalRegExp& regexp) const
{
    bool &ret = *(bool*) userData;
    ret = RegExpEpsilon::REG_EXP_EPSILON.languageContainsEpsilon(regexp);
}

void RegExpEpsilon::Visit(void* userData, const regexp::UnboundedRegExp& regexp) const
{
    bool &ret = *(bool*) userData;
    ret = RegExpEpsilon::REG_EXP_EPSILON.languageContainsEpsilon(regexp);
}

const RegExpEpsilon RegExpEpsilon::REG_EXP_EPSILON;

} /* namespace regexp */
