/*
 * RegExpEpsilon.h
 *
 *  Created on: 19. 1. 2014
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_EPSILON_H_
#define REG_EXP_EPSILON_H_

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExpElements.h>
#include <regexp/unbounded/UnboundedRegExpElements.h>

namespace regexp
{

/**
 * Calculates languageContainsEpsilon of regular expression.
 *
 */
class RegExpEpsilon : public regexp::VisitableRegExpBase::const_visitor_type
{
public:
    static bool languageContainsEpsilon(const regexp::RegExp& regexp);

    static bool languageContainsEpsilon(const regexp::FormalRegExp& regexp);
    static bool languageContainsEpsilon(const regexp::UnboundedRegExp& regexp);

private:
    void Visit(void* data, const regexp::UnboundedRegExp& regexp) const;
    void Visit(void* data, const regexp::FormalRegExp& regexp) const;

    static const RegExpEpsilon REG_EXP_EPSILON;
};

} /* namespace regexp */

#endif /* REG_EXP_EPSILON_H_ */
