#include <list>
#include "normalizeTest.h"

#include "label/StringLabel.h"
#include "label/IntegerLabel.h"
#include "label/Label.h"
#include "alphabet/LabeledSymbol.h"

#include "normalize/dfa/NormalizeDFA.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_REGISTRATION( normalizeTest );

void normalizeTest::setUp() {
}

void normalizeTest::tearDown() {
}

void normalizeTest::testNormalize() {
  automaton::DFA automaton(automaton::State(label::Label(label::IntegerLabel(0))));

  automaton.addState(automaton::State(label::Label(label::IntegerLabel(0))));
  automaton.addState(automaton::State(label::Label(label::IntegerLabel(1))));
  automaton.addState(automaton::State(label::Label(label::IntegerLabel(2))));
  automaton.addInputSymbol(alphabet::Symbol(alphabet::LabeledSymbol(label::Label(label::StringLabel("a")))));
  automaton.addInputSymbol(alphabet::Symbol(alphabet::LabeledSymbol(label::Label(label::StringLabel("b")))));
  
  automaton.addTransition(automaton::State(label::Label(label::IntegerLabel(0))), alphabet::Symbol(alphabet::LabeledSymbol(label::Label(label::StringLabel("a")))), automaton::State(label::Label(label::IntegerLabel(1))));
  automaton.addTransition(automaton::State(label::Label(label::IntegerLabel(1))), alphabet::Symbol(alphabet::LabeledSymbol(label::Label(label::StringLabel("b")))), automaton::State(label::Label(label::IntegerLabel(2))));

  automaton.addFinalState(automaton::State(label::Label(label::IntegerLabel(2))));
  
  automaton::DFA normalized = normalize::NormalizeDFA::normalize(automaton);

  CPPUNIT_ASSERT(normalized.getStates().size() == 3);

  CPPUNIT_ASSERT(automaton == normalized);
}
