#include <sstream>

#include "RegExpDerivationTest.h"

#include "regexp/RegExpDerivation.h"

#include <regexp/RegExpFromStringParser.h>
#include <regexp/RegExpToStringComposer.h>
#include <string/StringFromStringParser.h>

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_REGISTRATION( RegExpDerivationTest );

void RegExpDerivationTest::setUp() {
}

void RegExpDerivationTest::tearDown() {
}

void RegExpDerivationTest::testRegExpDerivation() {
    // https://edux.fit.cvut.cz/oppa/BI-AAG/cviceni/aag-cv04.pdf

    // Exc. 13
    this->ExecSingleTest("010 + 101 + 01*1 + 1*0", "0", "#E 1 0+#0 0 1+#E 0* 1+#0+#0 1* 0+#E");
    this->ExecSingleTest("010 + 101 + 01*1 + 1*0", "0 0", "#0 1 0+#0 0+#0 0 1+(#0 0*+#E 0*) 1+#0+#0+#0 1* 0+#0");

    // Exc. 14
    this->ExecSingleTest("(01*0 + 10*)*", "1", "(#0 1* 0+#E 0*) (0 1* 0+1 0*)*");
    this->ExecSingleTest("(01*0 + 10*)*", "1 0", "(#0 1* 0+#0 0*+#E 0*) (0 1* 0+1 0*)*+(#E 1* 0+#0 0*) (0 1* 0+1 0*)*");

    // Exc. 15
    this->ExecSingleTest("10*1*0", "100", "#0 0* 1* 0+(#0 0*+#E 0*) 1* 0+#0 1* 0+#E+#0 1* 0+#0");
}

void RegExpDerivationTest::ExecSingleTest(std::string regexp_str, std::string string_str, std::string result) {
    std::stringstream regexp_ss(regexp_str);
    regexp::RegExpFromStringParser regexp_parser(regexp_ss);
    regexp::RegExp regexp = regexp_parser.parseValue();

    std::stringstream string_ss("\"" + string_str + "\"");
    string::StringFromStringParser string_parser(string_ss);
    string::String string = string_parser.parseValue();

    regexp::RegExpDerivation d;
    regexp::RegExpToStringComposer regexp_composer;

    // TODO
    // CPPUNIT_ASSERT(regexp_composer.compose(d.derivation(regexp, string)) == result);
}
