/*
 * Symbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_H_
#define SYMBOL_H_

#include "../std/visitor.hpp"
#include "SymbolBase.h"
#include "../common/wrapper.hpp"

#include <set>

namespace alphabet {

/**
 * Wrapper around automata.
 */
typedef alib::wrapper<SymbolBase> Symbol;

/**
 * Creates and adds unique state to grammar. If given state name is
 * already used, appends apostrophe or integer suffix
 * @param name name of the state
 * @throws AutomatonException if symbol could not be created
 * @return created symbol
 */
alphabet::Symbol createUniqueSymbol(const alphabet::Symbol& base, const std::set<alphabet::Symbol>& Terminals, const std::set<alphabet::Symbol>& nonterminals);

} /* namespace alphabet */

#endif /* SYMBOL_H_ */

