/*
 * SymbolBase.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_BASE_H_
#define SYMBOL_BASE_H_

#include "../common/base.hpp"
#include "../object/ObjectBase.h"

namespace alphabet {

typedef std::acceptor_base<
			LabeledSymbol, BlankSymbol, BottomOfTheStackSymbol, EndSymbol
	> VisitableSymbolBase;

/**
 * Represents symbol in an alphabet.
 */
class SymbolBase : public alib::ObjectBase, public VisitableSymbolBase {
public:
	using VisitableSymbolBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual SymbolBase* clone() const = 0;
	virtual SymbolBase* plunder() && = 0;

};

} /* namespace alphabet */

#endif /* SYMBOL_BASE_H_ */
