/*
 * SingleInitialSymbolPushdownStore.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef SINGLE_INITIAL_SYMBOL_PUSHDOWN_STORE_ALPHABET_H_
#define SINGLE_INITIAL_SYMBOL_PUSHDOWN_STORE_ALPHABET_H_

#include <set>
#include "../../alphabet/Symbol.h"
#include "PushdownStoreAlphabet.h"

namespace automaton {

/**
 * Push Down Automaton
 */
class SingleInitialSymbolPushdownStoreAlphabet : public PushdownStoreAlphabet {
protected:
	alphabet::Symbol initialSymbol;
public:
	SingleInitialSymbolPushdownStoreAlphabet(const alphabet::Symbol& initialSymbol);

	/**
	 * Set initial symbol. Initial symbol is symbol that is pushed
	 * to the stack when SingleInitialSymbolPushdownStore is created.
	 * @param start new initial symbol
	 * @throws AutomatonException when symbol is not present in the stack alphabet
	 */
	void setInitialSymbol(const alphabet::Symbol& start);
	
	
	/**
	 * @return list of start symbols
	 */
	const alphabet::Symbol& getInitialSymbol() const;

};

} /* namespace automaton */

#endif /* SINGLE_INITIAL_SYMBOL_PUSHDOWN_STORE_ALPHABET_H_ */
