/*
 * ContainerFromXMLParser.cpp
 *
 *  Created on: Oct 12, 2013
 *      Author: Jan Travnicek
 */

#include "ContainerFromXMLParser.hpp"
#include "../sax/ParserException.h"

namespace container {

bool ContainerFromXMLParser::first(std::list<sax::Token>& input) const {
	if(isToken(input, sax::Token::TokenType::START_ELEMENT, "set")) {
		return true;
	} else {
		return false;
	}
}

Container ContainerFromXMLParser::parseContainer(std::list<sax::Token>& input) const {
	return parseContainer(input, std::set<FEATURES>({FEATURES::SET}));
}

Container ContainerFromXMLParser::parseContainer(std::list<sax::Token>& input, const std::set<FEATURES>& features) const {
	if(isToken(input, sax::Token::TokenType::START_ELEMENT, "set")) {
		if(!features.count(FEATURES::SET)) throw exception::AlibException();
		return Container(parseObjectsSet(input));
	} else {
		throw sax::ParserException(sax::Token("set", sax::Token::TokenType::START_ELEMENT), input.front());
	}
}

ObjectsSet ContainerFromXMLParser::parseObjectsSet(std::list<sax::Token>& input) const {
	popToken(input, sax::Token::TokenType::START_ELEMENT, "set");

	ObjectsSet set;

	while(isTokenType(input, sax::Token::TokenType::START_ELEMENT)) {
		set.insert(alib::api<alib::Object>::parse(input));
	}

	popToken(input, sax::Token::TokenType::END_ELEMENT, "set");
	return set;
}

} /* namespace container */

