/*
 * Set.h
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef SET_H_
#define SET_H_

#include <set>
#include <string>

#include "../object/Object.h"
#include "ContainerBase.h"

namespace container {

/**
 * Basic container from which are derived all other containers.
 * Contains reason why the container occured.
 */
class ObjectsSet : public std::set<alib::Object>, public std::acceptor<ObjectsSet, VisitableContainerBase, std::acceptor<ObjectsSet, alib::VisitableObjectBase, ContainerBase> > {
public:
	virtual ContainerBase* clone() const;
	
	virtual ContainerBase* plunder() &&;

	virtual bool operator>(const alib::ObjectBase& other) const;
	virtual bool operator==(const alib::ObjectBase& other) const;
	virtual bool operator<(const alib::ObjectBase& other) const;

	virtual bool operator==(const ObjectsSet& other) const;
	virtual bool operator<(const ObjectsSet& other) const;

	virtual void operator>>(std::ostream& os) const;

	virtual operator std::string() const;

	virtual int selfTypeId() const {
		return typeId(*this);
	}
};

} /* namespace container */

#endif /* SET_H_ */
