/*
 * GrammarFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_FROM_STRING_PARSER_H_
#define GRAMMAR_FROM_STRING_PARSER_H_

#include "GrammarFromStringLexer.h"
#include "../alphabet/SymbolFromStringParser.h"

#include "Grammar.h"
#include "GrammarFeatures.h"

namespace grammar {

class GrammarFromStringParser : public alib::FromStringParser<Grammar, FEATURES> {
	GrammarFromStringLexer m_GrammarLexer;
	alphabet::SymbolFromStringParser m_SymbolParser;

	std::set<alphabet::Symbol> parseSet();
	void parseRules(UnknownGrammar& res);

	UnknownGrammar parseUnknownGrammar();
	virtual bool last();
	Grammar parse();
	Grammar parse(const std::set<FEATURES>& features);
	bool next();

public:
	GrammarFromStringParser(std::istream& input);

	bool first();
};

} /* namespace grammar */

#endif /* GRAMMAR_FROM_STRING_PARSER_H_ */
