/*
 * CharacterLabel.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef CHARACTER_LABEL_H_
#define CHARACTER_LABEL_H_

#include <string>
#include <ostream>

#include "LabelBase.h"

namespace label {

/**
 * Represents symbol in an alphabet.
 */
class CharacterLabel : public std::acceptor<CharacterLabel, VisitableLabelBase, std::acceptor<CharacterLabel, alib::VisitableObjectBase, LabelBase> > {
protected:
	char label;
public:
	virtual LabelBase* clone() const;

	virtual LabelBase* plunder() &&;

	/**
	 * Creates new symbol with given name.
	 * @param symbol name of the symbol
	 */
	explicit CharacterLabel(char label);

	virtual bool operator<(const alib::ObjectBase& other) const;

	virtual bool operator>(const alib::ObjectBase& other) const;

	virtual bool operator==(const alib::ObjectBase& other) const;

	/**
	 * @return name of the symbol
	 */
	char getData() const;

	virtual bool operator <(const CharacterLabel& other) const;
	virtual bool operator ==(const CharacterLabel& other) const;

	virtual void operator>>(std::ostream&) const;

	virtual operator std::string () const;

	virtual int selfTypeId() const {
		return typeId(*this);
	}
};

} /* namespace label */

#endif /* CHARACTER_LABEL_H_ */

