/*
 * IntegerLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author:Jan Travnicek 
 */

#include "IntegerLabel.h"

namespace label {

IntegerLabel::IntegerLabel(int label) : label(label) {

}

LabelBase* IntegerLabel::clone() const {
	return new IntegerLabel(*this);
}

LabelBase* IntegerLabel::plunder() && {
	return new IntegerLabel(std::move(*this));
}

int IntegerLabel::getData() const {
	return label;
}

bool IntegerLabel::operator <(const alib::ObjectBase& other) const {
	return other > *this;
}

bool IntegerLabel::operator ==(const alib::ObjectBase& other) const {
	return other == *this;
}

bool IntegerLabel::operator >(const alib::ObjectBase& other) const {
	return other < *this;
}

bool IntegerLabel::operator <(const IntegerLabel& other) const {
	return label < other.label;
}

bool IntegerLabel::operator ==(const IntegerLabel& other) const {
	return label == other.label;
}

void IntegerLabel::operator>>(std::ostream& out) const {
	out << "(IntegerLabel " << label << ")";
}

IntegerLabel::operator std::string() const {
	return std::to_string(label);
}

} /* namespace label */

