/*
 * LabelBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_BASE_H_
#define LABEL_BASE_H_

#include "../common/base.hpp"
#include "../object/ObjectBase.h"

namespace label {

typedef std::acceptor_base<
			label::StringLabel, label::IntegerLabel, label::CharacterLabel, label::LabelSetLabel, label::LabelPairLabel
	> VisitableLabelBase;

/**
 * Abstract base class for all automata.
 */
class LabelBase : public alib::ObjectBase, public VisitableLabelBase {
public:
	using VisitableLabelBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual LabelBase* clone() const = 0;
	virtual LabelBase* plunder() && = 0;

};

} /* namespace label */

#endif /* LABEL_BASE_H_ */

