/*
 * LabelFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_FROM_STRING_LEXER_H_
#define LABEL_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace label {

class LabelFromStringLexer {
public:
	enum class TokenType {
		STRING,
		CHAR,
		INTEGER,
		SET_BEGIN,
		SET_END,
		PAIR_BEGIN,
		PAIR_END,
		COMMA,
		TEOF,
		ERROR
	};

	struct Token {
	      TokenType type;
	      std::string value;
	};
private:
	std::istream& m_In;
	Token m_Current;
public:

	LabelFromStringLexer(std::istream&);
	LabelFromStringLexer& next();
	Token token();
};

} /* namespace label */

#endif /* LABEL_FROM_STRING_LEXER_H_ */
