/*
 * StringLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "StringLabel.h"

namespace label {

StringLabel::StringLabel(const std::string& label) : label(label) {

}

StringLabel::StringLabel(std::string&& label) : label(std::move(label)) {

}

LabelBase* StringLabel::clone() const {
	return new StringLabel(*this);
}

LabelBase* StringLabel::plunder() && {
	return new StringLabel(std::move(*this));
}

const std::string& StringLabel::getData() const {
	return label;
}

bool StringLabel::operator<(const alib::ObjectBase& other) const {
	return other > *this;
}

bool StringLabel::operator==(const alib::ObjectBase& other) const {
	return other == *this;
}

bool StringLabel::operator >(const alib::ObjectBase& other) const {
	return other < *this;
}


bool StringLabel::operator <(const StringLabel& other) const {
	return label < other.label;
}

bool StringLabel::operator ==(const StringLabel& other) const {
	return label == other.label;
}

void StringLabel::operator>>(std::ostream& out) const {
	out << "(StringLabel " << label << ")";
}

StringLabel::operator std::string() const {
	return label;
}

} /* namespace label */

