/*
 * ObjectToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef OBJECT_TO_XML_COMPOSER_H_
#define OBJECT_TO_XML_COMPOSER_H_

#include <list>
#include "Object.h"
#include "../sax/Token.h"
#include "../label/Label.h"

namespace alib {

template<typename T>
struct api;

} /* namespace alib */

namespace alib {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class ObjectToXMLComposer {
	/**
	 * Prints XML representation of UnknownAutomaton to the output stream.
	 * @param automaton automaton to print
	 * @return list of xml tokens representing the automaton
	 */
	std::list<sax::Token> compose(const ObjectBase& object) const;

	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const Object& object) const;

	template<typename T> friend class alib::api;
};

} /* namespace alib */

#endif /* OBJECT_TO_XML_COMPOSER_H_ */
