/*
 * RegExpAlphabetGetter.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_ALPHABET_GETTER_H_
#define REG_EXP_ALPHABET_GETTER_H_

#include <set>
#include "RegExp.h"
#include "../alphabet/Symbol.h"
#include "unbounded/UnboundedRegExp.h"
#include "formal/FormalRegExp.h"

namespace regexp {

class RegExpAlphabetGetter : public VisitableRegExpBase::const_visitor_type {
	void Visit(void*, const UnboundedRegExp& empty) const;
	void Visit(void*, const FormalRegExp& empty) const;

public:
	/**
	 * Composes string representation of RegExp.
	 * @param regexp RegExp to print
	 * @returns string representation of regexp
	 */
	std::set<alphabet::Symbol> getAlphabet(const RegExp& regexp) const;

	static const RegExpAlphabetGetter REG_EXP_ALPHABET_GETTER;
};

} /* namespace regexp */

#endif /* REG_EXP_ALPHABET_GETTER_H_ */
