/*
 * UnboundedRegExpElement.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "UnboundedRegExpElement.h"
#include <typeinfo>

#include "UnboundedRegExpElements.h"

namespace regexp {

UnboundedRegExpElement::UnboundedRegExpElement() : parentRegExp(NULL) {

}

UnboundedRegExpElement::~UnboundedRegExpElement() noexcept {

}

bool UnboundedRegExpElement::operator>=(const UnboundedRegExpElement& other) const {
	return !(*this < other);
}

bool UnboundedRegExpElement::operator<=(const UnboundedRegExpElement& other) const {
	return !(*this > other);
}

bool UnboundedRegExpElement::operator!=(const UnboundedRegExpElement& other) const {
	return !(*this == other);
}


bool UnboundedRegExpElement::operator<(const UnboundedRegExpConcatenation& other) const {
	return typeid(*this).before(typeid(other));
}

bool UnboundedRegExpElement::operator<(const UnboundedRegExpAlternation& other) const {
	return typeid(*this).before(typeid(other));
}

bool UnboundedRegExpElement::operator<(const UnboundedRegExpIteration& other) const {
	return typeid(*this).before(typeid(other));
}

bool UnboundedRegExpElement::operator<(const UnboundedRegExpSymbol& other) const {
	return typeid(*this).before(typeid(other));
}

bool UnboundedRegExpElement::operator<(const UnboundedRegExpEpsilon& other) const {
	return typeid(*this).before(typeid(other));
}

bool UnboundedRegExpElement::operator<(const UnboundedRegExpEmpty& other) const {
	return typeid(*this).before(typeid(other));
}


bool UnboundedRegExpElement::operator==(const UnboundedRegExpConcatenation&) const {
	return false;
}

bool UnboundedRegExpElement::operator==(const UnboundedRegExpAlternation&) const {
	return false;
}

bool UnboundedRegExpElement::operator==(const UnboundedRegExpIteration&) const {
	return false;
}

bool UnboundedRegExpElement::operator==(const UnboundedRegExpSymbol&) const {
	return false;
}

bool UnboundedRegExpElement::operator==(const UnboundedRegExpEpsilon&) const {
	return false;
}

bool UnboundedRegExpElement::operator==(const UnboundedRegExpEmpty&) const {
	return false;
}

std::ostream& operator<<(std::ostream& out, const UnboundedRegExpElement& regexp) {
	regexp >> out;
	return out;
}

} /* namespace regexp */
