/*
 * StringAlphabetGetter.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_ALPHABET_GETTER_H_
#define STRING_ALPHABET_GETTER_H_

#include <set>
#include "String.h"
#include "../alphabet/Symbol.h"
#include "CyclicString.h"
#include "LinearString.h"
#include "Epsilon.h"

namespace string {

class StringAlphabetGetter : public VisitableStringBase::const_visitor_type {
	void Visit(void*, const CyclicString& empty) const;
	void Visit(void*, const Epsilon& empty) const;
	void Visit(void*, const LinearString& empty) const;

public:
	/**
	 * Composes string representation of String.
	 * @param string String to print
	 * @returns string representation of string
	 */
	std::set<alphabet::Symbol> getAlphabet(const String& string) const;

	static const StringAlphabetGetter STRING_ALPHABET_GETTER;
};

} /* namespace string */

#endif /* STRING_ALPHABET_GETTER_H_ */
