/*
 * StringToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef STRING_TO_STRING_COMPOSER_H_
#define STRING_TO_STRING_COMPOSER_H_

#include <sstream>
#include "String.h"
#include "../sax/Token.h"
#include "../alphabet/Symbol.h"

namespace string {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class StringToStringComposer : public VisitableStringBase::visitor_type {
	void Visit(void*, const LinearString& string);
	void Visit(void*, const CyclicString& string);
	void Visit(void*, const Epsilon& string);
public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::string compose(const String& string);
};

} /* namespace string */

#endif /* STRING_TO_STRING_COMPOSER_H_ */
