#include <list>
#include "ContainerTest.h"

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#include "object/Object.h"
#include "container/ObjectsSet.h"
#include "alphabet/LabeledSymbol.h"

#include "factory/DataFactory.hpp"

#include "label/StringLabel.h"
#include "label/Label.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))
#define CPPUNIT_EXCLUSIVE_OR(x, y) CPPUNIT_ASSERT((!(x) && (y)) || ((x) && !(y)))

CPPUNIT_TEST_SUITE_REGISTRATION( ContainerTest );

void ContainerTest::setUp() {
}

void ContainerTest::tearDown() {
}

void ContainerTest::testXMLParser() {

  alib::Object tmp(alphabet::LabeledSymbol(label::Label(label::StringLabel("1"))));

  container::ObjectsSet set;
  set.insert(tmp);

  alib::Object object(set);

  {
	std::string tmp = alib::DataFactory::toString(object);
	alib::Object object2 = alib::DataFactory::fromString<alib::Object>(tmp);
  
	CPPUNIT_ASSERT( object == object2 );

	std::set<alphabet::LabeledSymbol> concrete = alib::DataFactory::fromString<std::set<alphabet::LabeledSymbol>>(tmp);
	std::string tmp2 = alib::DataFactory::toString(concrete);

	CPPUNIT_ASSERT( tmp == tmp2 );
  }
}

